<?php

/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\ResetMapping;

use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Magento\Framework\App\Cache\Manager as CacheManager;
use Magento\Framework\App\Cache\Type\Config as CacheTypeConfig;

class Index extends \Magento\Backend\App\Action
{
    /** @var \Magento\Framework\View\Result\PageFactory */
    protected $_resultPageFactory;

    /** @var \Webkul\Eshopsync\Helper\Data */
    protected $_helper;

    /** @var \Magento\Config\Model\ResourceModel\Config */
    protected $_resourceConfig;

    /** @var \Webkul\Eshopsync\Model\CategoryFactory */
    protected $_eshopsyncCategory;

    /** @var \Webkul\Eshopsync\Model\ProductFactory */
    protected $_eshopsyncProduct;

    /** @var \Webkul\Eshopsync\Model\CustomerFactory */
    protected $_eshopsyncCustomer;

    /** @var \Webkul\Eshopsync\Model\OrderFactory */
    protected $_eshopsyncOrder;

    /** @var CacheManager */
    protected $_cacheTypeConfig;

    /** @var CacheTypeConfig */
    protected $_cacheManager;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Webkul\Eshopsync\Helper\Data $helper
     * @param \Magento\Config\Model\ResourceModel\Config $resourceConfig
     * @param \Webkul\Eshopsync\Model\CategoryFactory $eshopsyncCategory
     * @param \Webkul\Eshopsync\Model\ProductFactory $eshopsyncProduct
     * @param \Webkul\Eshopsync\Model\CustomerFactory $eshopsyncCustomer
     * @param \Webkul\Eshopsync\Model\OrderFactory $eshopsyncOrder
     * @param CacheManager $cacheManager
     * @param CacheTypeConfig $cacheTypeConfig
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        CacheManager $cacheManager,
        CacheTypeConfig $cacheTypeConfig,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Webkul\SalesforceConnector\Helper\Connection $helper
    ) {

        parent::__construct($context);
        $this->_resultPageFactory = $resultPageFactory;
        $this->_helper = $helper;
        $this->_cacheManager = $cacheManager;
        $this->_cacheTypeConfig = $cacheTypeConfig;
    }

    public function execute()
    {
        $this->_helper->revokeConnection();
        $this->_helper->resetFunction();
        $this->messageManager->addSuccess(__('Data reset successfully'));
        $resultRedirect = $this->resultRedirectFactory->create();
        $resultRedirect->setPath('admin/system_config/edit/section/sfConnect/');
        return $resultRedirect;
    }

    /*
     * Check permission via ACL resource
     */
    // protected function _isAllowed()
    // {
    //     return $this->_authorization->isAllowed('Webkul_Eshopsync::resetmapping_index');
    // }
}
