<?php

/**
 * * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\System\Config\Connection;

use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\App\PageCache\Version;
use Magento\Framework\App\Cache\TypeListInterface;
use Magento\Framework\App\Cache\Frontend\Pool;

class RecordContact extends \Webkul\SalesforceConnector\Controller\Adminhtml\System\Config\Connection
{
    /**
     * @var JsonFactory
     */
    protected $_json;
    protected $writerInterface;
    protected $_curl;
    protected $cacheTypeList;
    protected $cacheFrontendPool;
    protected $_helper;
    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Webkul\Eshopsync\Helper\Connection $connection
     * @param \Webkul\Eshopsync\Helper\Data $helper
     * @param \Magento\Config\Model\ResourceModel\Config $resourceConfig
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\HTTP\Client\Curl $curl
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Magento\Framework\App\Config\Storage\WriterInterface $writerInterface,
        TypeListInterface $cacheTypeList,
        Pool $cacheFrontendPool,
        \Magento\Framework\HTTP\Client\Curl $curl,
        \Webkul\SalesforceConnector\Helper\Connection $helper
    ) {

        parent::__construct($context);
        $this->writerInterface = $writerInterface;
        $this->_json = $jsonHelper;
        $this->_curl = $curl;
        $this->_helper = $helper;
        $this->cacheTypeList = $cacheTypeList;
        $this->cacheFrontendPool = $cacheFrontendPool;
    }

    public function execute()
    { 
        
        $post = $this->getRequest()->getPostValue();
        $searchString = $post['searchString'];
        $response = $this->_helper->getSObject("SELECT Id,Name FROM RecordType where SobjectType = 'Contact' AND Name LIKE '$searchString%' LIMIT 10", 10, 1);
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($this->_json->jsonEncode($response));
    }

}
