<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\SalesforceConnector\Model\Config\Source;

class RecordAcc implements \Magento\Framework\Option\ArrayInterface
{
    
    protected $_data;
    protected $_helper;
    public function __construct(
        \Webkul\SalesforceConnector\Helper\Connection $helper,
        \Webkul\SalesforceConnector\Helper\Data $data
    ) {
        $this->_data = $data;
        $this->_helper = $helper;
    }
    public function toOptionArray()
    {
        
        // show incompatible message : TODO: move check to proper file/controller
        // get messenger interface
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $magentoMessenger = $objectManager->create('\Magento\Framework\Message\ManagerInterface');
        $magentoMetaData = $objectManager->create('\Magento\Framework\App\ProductMetadataInterface');
        $appEdition = $this->_data->getConfigValue('general', 'mgedition');
        // if ($magentoMetaData->getEdition() != 'Community' && $appEdition == 0) {
        //     $magentoMessenger->addError("Incompatible App, Communtiy eddition app is installed on different Magento edition");
        // }
        // end compatibility check
        $data = [];
        $conStatus = $this->_data->getConfigValue('general', 'connection_status');
        if ($conStatus) {
            $recordtypes = isset($this->_helper->_sfconfigData['AccountRecordType'])
            ? $this->_helper->_sfconfigData['AccountRecordType']
            :'';
            if (isset($recordtypes) && !empty($recordtypes)) {
                foreach ($recordtypes as $key => $record) {
                    array_push(
                        $data,
                        [
                            'id' => $record['value'],
                            'name' => $record['text'],
                        ]
                    );

                }
            } else {
               return [];
            }

        } else {
            return [];
        }
                return $data;
    }
}
